// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by a MIT-style license
// that can be found in the LICENSE file.

library passive_data.test.utils_test;

import 'package:test/test.dart';
import 'package:passive_data/passive_data.dart';

void main() {
  test('Test generateCodeFromPds()', () {
    expect(generatePdsCode('String', 'd'), equals('d'));
    expect(generatePdsCode('List<Point>', 'd'), equals('toPdsList(d)'));
    expect(generatePdsCode('Set<Point>', 'd'), equals('toPdsSet(d)'));
    expect(generatePdsCode('Map<int, Point>', 'd'), equals('toPdsMap(d)'));
    expect(generatePdsCode('Point', 'd'), equals('d.toPds()'));
  });

  test('Test generateDataFromPdsCode()', () {
    expect(generateCodeFromPds('dynamic', 'value'), equals('value'));
    expect(generateCodeFromPds('String', 'value'), equals('value as String'));
    expect(generateCodeFromPds('Map<String, Map<int, dynamic>>', 'value'),
        equals('value as Map<String,Map<int,dynamic>>'));
    expect(
        generateCodeFromPds('List<Set<MyObject>>', 'value', 'List<Set<int>>'),
        equals('''
new List<Set<MyObject>>.generate(value.length,
 (int i1) => new List<MyObject>.generate(value[i1].length,
 (int i2) => new MyObject.fromPds(value[i1][i2] as int)).toSet())'''
            .replaceAll('\n', '')));
    expect(
        generateCodeFromPds(
            'List<Set<MyObject>>', 'value', 'List<Set<dynamic>>'),
        equals('''
new List<Set<MyObject>>.generate(value.length,
 (int i1) => new List<MyObject>.generate(value[i1].length,
 (int i2) => new MyObject.fromPds(value[i1][i2])).toSet())'''
            .replaceAll('\n', '')));
  });
}
